/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import DeleteTrade from '../model/DeleteTrade';
import ForceBuyPayload from '../model/ForceBuyPayload';
import ForceBuyResponse from '../model/ForceBuyResponse';
import ForceSellPayload from '../model/ForceSellPayload';
import HTTPValidationError from '../model/HTTPValidationError';
import OpenTradeSchema from '../model/OpenTradeSchema';
import ResultMsg from '../model/ResultMsg';

/**
* Trading service.
* @module ftclient/TradingApi
* @version 2021.12-dev21
*/
export default class TradingApi {

    /**
    * Constructs a new TradingApi. 
    * @alias module:ftclient/TradingApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }



    /**
     * Forcebuy
     * @param {module:model/ForceBuyPayload} forceBuyPayload 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ForceBuyResponse} and HTTP response
     */
    forcebuyApiV1ForcebuyPostWithHttpInfo(forceBuyPayload) {
      let postBody = forceBuyPayload;
      // verify the required parameter 'forceBuyPayload' is set
      if (forceBuyPayload === undefined || forceBuyPayload === null) {
        throw new Error("Missing the required parameter 'forceBuyPayload' when calling forcebuyApiV1ForcebuyPost");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = ForceBuyResponse;
      return this.apiClient.callApi(
        '/api/v1/forcebuy', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Forcebuy
     * @param {module:model/ForceBuyPayload} forceBuyPayload 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ForceBuyResponse}
     */
    forcebuyApiV1ForcebuyPost(forceBuyPayload) {
      return this.forcebuyApiV1ForcebuyPostWithHttpInfo(forceBuyPayload)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Forcesell
     * @param {module:model/ForceSellPayload} forceSellPayload 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ResultMsg} and HTTP response
     */
    forcesellApiV1ForcesellPostWithHttpInfo(forceSellPayload) {
      let postBody = forceSellPayload;
      // verify the required parameter 'forceSellPayload' is set
      if (forceSellPayload === undefined || forceSellPayload === null) {
        throw new Error("Missing the required parameter 'forceSellPayload' when calling forcesellApiV1ForcesellPost");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = ResultMsg;
      return this.apiClient.callApi(
        '/api/v1/forcesell', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Forcesell
     * @param {module:model/ForceSellPayload} forceSellPayload 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ResultMsg}
     */
    forcesellApiV1ForcesellPost(forceSellPayload) {
      return this.forcesellApiV1ForcesellPostWithHttpInfo(forceSellPayload)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Trade
     * @param {Number} tradeid 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/OpenTradeSchema} and HTTP response
     */
    tradeApiV1TradeTradeidGetWithHttpInfo(tradeid) {
      let postBody = null;
      // verify the required parameter 'tradeid' is set
      if (tradeid === undefined || tradeid === null) {
        throw new Error("Missing the required parameter 'tradeid' when calling tradeApiV1TradeTradeidGet");
      }

      let pathParams = {
        'tradeid': tradeid
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = OpenTradeSchema;
      return this.apiClient.callApi(
        '/api/v1/trade/{tradeid}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Trade
     * @param {Number} tradeid 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/OpenTradeSchema}
     */
    tradeApiV1TradeTradeidGet(tradeid) {
      return this.tradeApiV1TradeTradeidGetWithHttpInfo(tradeid)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Trades
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit  (default to 500)
     * @param {Number} opts.offset  (default to 0)
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Object} and HTTP response
     */
    tradesApiV1TradesGetWithHttpInfo(opts) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'limit': opts['limit'],
        'offset': opts['offset']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Object;
      return this.apiClient.callApi(
        '/api/v1/trades', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Trades
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit  (default to 500)
     * @param {Number} opts.offset  (default to 0)
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Object}
     */
    tradesApiV1TradesGet(opts) {
      return this.tradesApiV1TradesGetWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Trades Delete
     * @param {Number} tradeid 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/DeleteTrade} and HTTP response
     */
    tradesDeleteApiV1TradesTradeidDeleteWithHttpInfo(tradeid) {
      let postBody = null;
      // verify the required parameter 'tradeid' is set
      if (tradeid === undefined || tradeid === null) {
        throw new Error("Missing the required parameter 'tradeid' when calling tradesDeleteApiV1TradesTradeidDelete");
      }

      let pathParams = {
        'tradeid': tradeid
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = DeleteTrade;
      return this.apiClient.callApi(
        '/api/v1/trades/{tradeid}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Trades Delete
     * @param {Number} tradeid 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/DeleteTrade}
     */
    tradesDeleteApiV1TradesTradeidDelete(tradeid) {
      return this.tradesDeleteApiV1TradesTradeidDeleteWithHttpInfo(tradeid)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


}
